import { clearScreen, fillRect } from "./window.ts";
import { codetab } from "./codetab.ts";
import { spritetab } from "./spritetab.ts";
import { COLOR } from "./colors.ts";

// deno-lint-ignore prefer-const
let tab: "code" | "sprite" | "map" | "sfx" | "music" = "sprite";

const update = () => {
	if (tab === "code") {
		codetab.update();
	} else if (tab === "sprite") {
		spritetab.update();
	}
}

const draw = () => {
	clearScreen();
	if (tab === "code") {
		codetab.draw();
	} else if (tab === "sprite") {
		spritetab.draw();
	}
	fillRect(0, 0, 128, 8, COLOR.RED);
	fillRect(0, 120, 128, 8, COLOR.RED);
}

export const editmode = {
	update,
	draw,
}